<?php

/*
Argos, basic PHP web stats without database.
Coded by Daniele Lucchini (http://www.litterae.eu) in December 2017.
Free for personal use.
Files: argos.php, argos.csv, geoplugin.class.php
*/

//contatore grezzo accessi
$accessi = file_get_contents("data/accessitotali.txt");
$accessi = intval($accessi)+1;
file_put_contents("data/accessitotali.txt",$accessi);

//IP da trascurare
require_once('data/start.php');

//call geoplugin class
require_once('geoplugin.class.php');
$geoplugin = new geoPlugin();

function getBrowser()
{
    $u_agent = $_SERVER['HTTP_USER_AGENT'];
    $bname = 'Unknown';
    $platform = 'Unknown';
    $version= "";

    //get OS
    if (preg_match('/linux/i', $u_agent)) {
        $platform = 'linux';
    }
    elseif (preg_match('/macintosh|mac os x/i', $u_agent)) {
        $platform = 'mac';
    }
    elseif (preg_match('/windows|win32/i', $u_agent)) {
        $platform = 'windows';
    }

    //get browser
    if(preg_match('/MSIE/i',$u_agent) && !preg_match('/Opera/i',$u_agent))
    {
        $bname = 'Internet Explorer';
        $ub = "MSIE";
    }
    elseif(preg_match('/Firefox/i',$u_agent))
    {
        $bname = 'Mozilla Firefox';
        $ub = "Firefox";
    }
    elseif(preg_match('/Chrome/i',$u_agent))
    {
        $bname = 'Google Chrome';
        $ub = "Chrome";
    }
    elseif(preg_match('/Safari/i',$u_agent))
    {
        $bname = 'Apple Safari';
        $ub = "Safari";
    }
    elseif(preg_match('/Opera/i',$u_agent))
    {
        $bname = 'Opera';
        $ub = "Opera";
    }
    elseif(preg_match('/Netscape/i',$u_agent))
    {
        $bname = 'Netscape';
        $ub = "Netscape";
    }

    //get browser version
    $known = array('Version', $ub, 'other');
    $pattern = '#(?<browser>' . join('|', $known) .
    ')[/ ]+(?<version>[0-9.|a-zA-Z.]*)#';
    if (!preg_match_all($pattern, $u_agent, $matches)) {
        // we have no matching number just continue
    }

    // see how many we have
    $i = count($matches['browser']);
    if ($i != 1) {
        //we will have two since we are not using 'other' argument yet
        //see if version is before or after the name
        if (strripos($u_agent,"Version") < strripos($u_agent,$ub)){
            $version= $matches['version'][0];
        }
        else {
            $version= $matches['version'][1];
        }
    }
    else {
        $version= $matches['version'][0];
    }

    // check if we have a number
    if ($version==null || $version=="") {$version="?";}

    return array(
        'userAgent' => $u_agent,
        'name'      => $bname,
        'version'   => $version,
        'platform'  => $platform,
        'pattern'    => $pattern
    );
}

//prepare data
$ua=getBrowser();
$ip=$_SERVER['REMOTE_ADDR'];
$lang=substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2);
$ref=$_SERVER['HTTP_REFERER'];
$page=basename($_SERVER['PHP_SELF']);
date_default_timezone_set("Europe/Rome");
$date=date("Y/m/d");
$day=date("l");
$hour=date("h:i:sa");
$geoplugin->locate();

$hostname = gethostbyaddr($_SERVER['REMOTE_ADDR']);

//
if ($ip !== $white) {

		/*
        //control via abuseipdb
        $abuseipdb="https://www.abuseipdb.com/check/".$ip;
        ini_set("user_agent","Argos, simple web stats tool - if Argos is disturbing, please contact http://www.litterae.eu/it/argos-simple-web-stats-tool/");
        $query=file_get_contents($abuseipdb);
        $start = strpos($query,"<meta name=Description content=");
        $stop = strpos($query,"/>",$start);
        $control = substr($query,$start+31,$stop-$start);
        if (strpos($control,"time") !== false) {
            // estrai report
            $from = strpos($query,"<p>This IP was reported <b>");
            $to = strpos($query,"</b>",$from);
            $times = substr($query,$from+27,$to-$from);
            $reports=intval($times);
            $from1 = strpos($query,"Confidence of Abuse is <b>");
            $to1 = strpos($query,"%</b>",$from1);
            $confidence = substr($query,$from1+26,$to1-$from1);
            // aggiorna blacklist
            if (intval($confidence) > 90) {
                $blacklist = fopen("data/black.csv","a");
                fputcsv($blacklist,array($date,intval($confidence)."%",intval($reports),$ip,$hostname));
                fclose($blacklist);
            }
            $suspect=intval($confidence)."%";
            } else {
            $reports="0";
            $suspect="0"."%";
            }
            */

        //update journal
        $journal = fopen("data/argos.csv", "a");
        fputcsv($journal, array($ua['name'],$ua['platform'],$ua['userAgent'],$ip,$lang,$ref,$page,$date,$day,$hour,$geoplugin->countryCode,$geoplugin->city,$geoplugin->longitude,$geoplugin->latitude,"","",$hostname));
        //fputcsv($journal, array($ua['name'],$ua['platform'],$ua['userAgent'],$ip,$lang,$ref,$page,$date,$day,$hour,$geoplugin->countryCode,$geoplugin->city,$geoplugin->longitude,$geoplugin->latitude,$reports,$suspect,$hostname));
        fclose($journal);

    } else { //do nothing
    }

?>
