<?php
	session_start();
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <!-- assets -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=yes">
    <link id="bootstrap5-stylesheet" href="libs/bootstrap.min.css" rel="stylesheet">
    <script id="bootstrap5-library" src="libs/bootstrap.bundle.min.js"></script>
    <style type="text/css">
        a:link { color: #990000; }
        a:visited { color: #990000; }
        a:hover { color: #990000; }
        a:active { color: #990000; }
        table, th, td { padding: 10px; border: 1px dotted #666; }
    </style>
    <?php require_once("libs/MiniFunx.php"); ?>
</head>

<body>
<?php
	// errors
	ini_set('display_errors', 1);
	ini_set('display_startup_errors', 1);
	error_reporting(E_ALL);

	// UI language
	$language = $_SESSION["lang"];
	require_once("lang/$language.php");
	require_once("data/psw.php");
	require_once("data/start.php");
?>
<!-- bootstrap container -->
<div class="container-fluid">
	<!-- head -->
	<div class="row">
		<div class="col-md-3"></div>
		<div class="col-md-6">
		   	<p align="center">
				<img src="argos-icon.png" width="60" height="60" style="float: left; margin: 5px;" />
				<font size="6"><b><a href="https://www.litterae.eu/it/argos-simple-web-stats-tool/">Argos</a></b></font><br>
				<font size="3"><?php echo $lang_slogan; ?> <a href="https://www.litterae.eu/">litterae.eu</a></font>
			</p>
		</div>
		<div class="col-md-3"></div>
	</div>

	<!-- body -->
	<div class="row">
    	<div class="col-md-1"></div>
		<div class="col-md-10">
		    <p align="left"><font size="3">
		    	<?php
					if (!isset($_SESSION["psw"]) || $_SESSION["psw"] !== $psw) {
						echo "$lang_wrong_psw<br><a href='index.php?lang=$language'>$lang_psw</a>";
						session_unset();
						session_destroy();
						exit();
					}
					$from = $_POST['dayfrom'];
					$to = $_POST['dayto'];
					echo "$lang_display_from $from $lang_display_to $to<hr>";
				?>
			</p>
			<p align="left"><font size="3">
				<table style='width:100%'>
					<tr>
						<th scope="col"><?php echo $lang_date; ?></th>
						<th scope="col"><?php echo $lang_time; ?></th>
						<th scope="col"><?php echo $lang_os; ?></th>
						<th scope="col"><?php echo $lang_browser; ?></th>
						<th scope="col"><?php echo $lang_lang; ?></th>
						<th scope="col"><?php echo $lang_country; ?></th>
						<th scope="col"><?php echo $lang_city; ?></th>
						<th scope="col"><?php echo $lang_map; ?></th>
						<th scope="col"><?php echo $lang_page; ?></th>
						<th scope="col"><?php echo $lang_ip; ?></th>
						<th scope="col"><?php echo $lang_host; ?></th>
					</tr>
					<?php
						// reset variables
						mkdir("temp");
						$vis_tot = $vis_uni = 0;
						$ip = $lingue = $paesi = $pagine = "";
						// read data
						$argos = fopen("data/argos.csv", "r");
						$conta_righe = 1;
						while (($dati = fgetcsv($argos,1000,",")) !== false) {
							if (strtotime($dati[7]) >= strtotime($from) && strtotime($dati[7]) <= strtotime($to) && !contains($dati[2],"bot")  && !contains($dati[2],"spider") && !contains($dati[2],"crawl") && !contains($dati[2],"ahref") && !contains($dati[16],"bot")  && !contains($dati[16],"spider") && !contains($dati[16],"crawl") && !contains($dati[16],"ahref")) {
								$conta_righe++;
								if ($conta_righe % 2 == 0) { $bgcolor = "#efefef"; } else { $bgcolor = "#ffffff"; }
								echo "<tr style='background-color:$bgcolor'><td>".$dati[7]."</td><td>".date("H:i",strtotime($dati[9]))."</td><td>".$dati[1]."</td><td>".$dati[0]."</td><td>".$dati[4]."</td><td>".$dati[10]."</td><td>".$dati[11]."</td><td><a target='_blank' href='https://www.google.it/maps/@".$dati[13].",".$dati[12].",13z'>🌐</a></td><td><a target='_blank' href='".$dati[5]."'>".$dati[5]."</a></td><td>".$dati[3]."</td><td>".$dati[16]."</td></tr>";
								// count visits
								$vis_tot++;
								if (!contains($ip,$dati[3])) {
									$ip = "$ip$dati[3],";
									$vis_uni++;
								}
								// count by language
								if (!file_exists("temp/lingua_$dati[4]")) {
									file_put_contents("temp/lingua_$dati[4]","1");
								} else {
									$quanti = file_get_contents("temp/lingua_$dati[4]");
									$quanti++;
									file_put_contents("temp/lingua_$dati[4]",$quanti);
								}
								// count by country
								if (!file_exists("temp/paese_$dati[10]")) {
									file_put_contents("temp/paese_$dati[10]","1");
								} else {
									$quanti = file_get_contents("temp/paese_$dati[10]");
									$quanti++;
									file_put_contents("temp/paese_$dati[10]",$quanti);
								}
								// count by page
								$dati[5] = str_replace(array("https://","http://","www.","$base/","?","/"),array("","","","","-","_"),$dati[5]);
								if ($dati[5] == "" || empty($dati[5])) {
									$dati[5] = $home;
								}
								if (contains($dati[5],"&")) {
									$toc = explode("?",$dati[5]);
									$dati[5] = $toc[0];
								}
								if (substr($dati[5],-1) == "_") {
									$dati[5] = rtrim($dati[5],"_");
								}
								if (!file_exists("temp/pagina_$dati[5]")) {
									file_put_contents("temp/pagina_$dati[5]","1");
								} else {
									$quanti = file_get_contents("temp/pagina_$dati[5]");
									$quanti++;
									file_put_contents("temp/pagina_$dati[5]",$quanti);
								}
							}
						}
						fclose($argos);
					?>
				</table>
				<hr>
			</p>
			<p>
				<?php
					// sort data
					// languages
					$files = scandir("temp");
					foreach($files as $file) {
						if (contains($file,"lingua_")) {
							$ling = str_replace("lingua_","",$file);
							if ($ling == "") {
								$ling = "n/i";
							}
							$iso_lingue =  array("ab","aa","af","ak","sq","am","ar","an","hy","as","av","ae","ay","az","bm","ba","eu","be","bn","bh","bi","bs","br","bg","my","ca","ch","ce","ny","zh","cu","cv","kw","co","cr","hr","cs","da","dv","nl","dz","en","eo","et","ee","fo","fj","fi","fr","fy","ff","gl","lg","ka","de","el","kl","gn","gu","ht","ha","he","hz","hi","ho","hu","is","io","ig","id","ia","ie","iu","ik","ga","it","ja","jv","kn","kr","ks","kk","km","ki","rw","ky","kv","kg","ko","kj","ku","lo","la","lv","li","ln","lt","lu","lb","mk","mg","ms","ml","mt","gv","mi","mr","mh","mo","mn","na","nv","nd","nr","ng","ne","no","nb","nn","oc","oj","or","om","os","pi","fa","pl","pt","pa","ps","qu","rm","ro","rn","ru","sm","sg","sa","sc","gd","sr","sn","ii","sd","si","sk","sl","so","st","es","su","sw","ss","sv","tl","ty","tg","ta","tt","te","th","bo","ti","to","ts","tn","tr","tk","tw","ug","uk","ur","uz","ve","vi","vo","wa","cy","wo","xh","yi","yo","za","zu");
							$count = 0;
							foreach ($iso_lingue as $iso_lingua) {
								if ($ling == $iso_lingua) {
									$ling = $lang_language_names[$count];
									break;
								} else {
									$count++;
								}
							}
							$lingue = $lingue.file_get_contents("temp/$file").", ".$ling."\n";
						}
					}
					$lingue_arr = explode("\n",$lingue);
					$lingue = $lingue_js = "";
					foreach ($lingue_arr as $lingua_arr) {
						$parti = explode(", ",$lingua_arr);
						$zeri = 9 - strlen($parti[0]);
						for ($x = 0; $x <= $zeri; $x++) {
							$parti[0] = " ".$parti[0];
						}
						if (isset($parti[1])) {
							$lingue = $lingue.$parti[0].", ".$parti[1]."\n";
							$lingue_js = $lingue_js.'			{ y: '.$parti[0].', label: '.'"'.$parti[1].'" },'."\n";
						}
					}
					$lingue_arr = explode("\n",$lingue);
					$lingue_js_arr = explode("\n",$lingue_js);
					rsort($lingue_arr);
					rsort($lingue_js_arr);
					$lingue_js_arr = array_slice($lingue_js_arr, 0, 10);
					$lingue = implode("\n",$lingue_arr);
					$lingua_js = implode("\n",$lingue_js_arr);
					$lingue = str_replace(" ","",$lingue);
					$lingue = str_replace(",",", ",$lingue);

					// countries
					$files = scandir("temp");
					foreach($files as $file) {
						if (contains($file,"paese_")) {
							$pae = str_replace("paese_","",$file);
							if ($pae == "") {
								$pae = "n/a";
							}
							$iso_paesi =  array("AF","AL","DZ","AD","AO","AI","AQ","AG","AN","SA","AR","AM","AW","AU","AT","AZ","BS","BH","BD","BB","BE","BZ","BJ","BM","BY","BT","BO","BA","BW","BR","BN","BG","BF","BI","KH","CM","CA","CV","TD","CL","CN","CY","VA","CO","KM","KP","KR","CR","CI","HR","CU","DK","DM","EC","EG","IE","SV","AE","ER","EE","ET","RU","FJ","PH","FI","FR","GA","GM","GE","DE","GH","JM","JP","GI","DJ","JO","GR","GD","GL","GP","GU","GT","GN","GW","GQ","GY","GF","HT","HN","HK","IN","ID","IR","IQ","BV","CX","HM","KY","CC","CK","FK","FO","MH","MP","UM","NF","SB","TC","VI","VG","IL","IS","IT","KZ","KE","KG","KI","KW","LA","LV","LS","LB","LR","LY","LI","LT","LU","MO","MK","MG","MW","MV","MY","ML","MT","MA","MQ","MR","MU","YT","MX","MD","MC","MN","MS","MZ","MM","NA","NR","NP","NI","NE","NG","NU","NO","NC","NZ","OM","NL","PK","PW","PA","PG","PY","PE","PN","PF","PL","PT","PR","QA","GB","CZ","CF","CG","CD","DO","RE","RO","RW","EH","KN","PM","VC","WS","AS","SM","SH","LC","ST","SN","XK","SC","SL","SG","SY","SK","SI","SO","ES","LK","FM","US","ZA","GS","SD","SR","SJ","SE","CH","SZ","TJ","TH","TW","TZ","IO","TF","PS","TL","TG","TK","TO","TT","TN","TR","TM","TV","UA","UG","HU","UY","UZ","VU","VE","VN","WF","YE","ZM","ZW","RS","ME","TP","GG","AX");
							$count = 0;
							foreach ($iso_paesi as $iso_paese) {
								if ($pae == $iso_paese) {
									$pae = $lang_country_names[$count];
									break;
								} else {
									$count++;
								}
							}
							$paesi = $paesi.file_get_contents("temp/$file").", ".$pae."\n";
						}
					}
					$paesi_arr = explode("\n",$paesi);
					$paesi = $paesi_js = "";
					foreach ($paesi_arr as $paese_arr) {
						$parti = explode(", ",$paese_arr);
						$zeri = 9 - strlen($parti[0]);
						for ($x = 0; $x <= $zeri; $x++) {
							$parti[0] = " ".$parti[0];
						}
						if (isset($parti[1])) {
							$paesi = $paesi.$parti[0].", ".$parti[1]."\n";
							$paesi_js = $paesi_js.'			{ y: '.$parti[0].', label: '.'"'.$parti[1].'" },'."\n";
						}
					}
					$paesi_arr = explode("\n",$paesi);
					$paesi_js_arr = explode("\n",$paesi_js);
					rsort($paesi_arr);
					rsort($paesi_js_arr);
					$paesi_js_arr = array_slice($paesi_js_arr, 0, 10);
					$paesi = implode("\n",$paesi_arr);
					$paese_js = implode("\n",$paesi_js_arr);
					$paesi = str_replace(" ","",$paesi);
					$paesi = str_replace(",",", ",$paesi);

					// pages
					$files = scandir("temp");
					foreach($files as $file) {
						if (contains($file,"pagina_")) {
							$pag = str_replace("pagina_","",$file);
							if ($pag == "") {
								$pag = "n/a";
							}
							$pagine = $pagine.file_get_contents("temp/$file").", ".$pag."\n";
						}
					}
					$pagine_arr = explode("\n",$pagine);
					$pagine = $pagine_js = "";
					foreach ($pagine_arr as $pagina_arr) {
						$parti = explode(", ",$pagina_arr);
						$zeri = 9 - strlen($parti[0]);
						for ($x = 0; $x <= $zeri; $x++) {
							$parti[0] = " ".$parti[0];
						}
						if (isset($parti[1])) {
							$pagine = $pagine.$parti[0].", ".$parti[1]."\n";
							$pagine_js = $pagine_js.'			{ y: '.$parti[0].', label: '.'"'.$parti[1].'" },'."\n";
						}
					}
					$pagine_arr = explode("\n",$pagine);
					$pagine_js_arr = explode("\n",$pagine_js);
					rsort($pagine_arr);
					rsort($pagine_js_arr);
					$pagine = implode("\n",$pagine_arr);
					$pagine_js_arr = array_slice($pagine_js_arr, 0, 10);
					$pagina_js = implode("\n",$pagine_js_arr);
					$pagine = str_replace(" ","",$pagine);
					$pagine = str_replace(",",", ",$pagine);

					// delete temp folder
					$files = scandir("temp");
					foreach ($files as $file) {
						if (!is_dir($file)) {
							unlink("temp/$file");
						}
					}
					rmdir("temp");

					// print aggregate results
					echo "<b>$lang_recap</b><br><br>
						$lang_total_visits: $vis_tot<br>
						$lang_unique_visits: $vis_uni<br><br>
						<u>$lang_language_visits</u>:<br>".
						str_replace("\n","<br>",$lingue)."<br><br>
						<u>$lang_country_visits</u>:<br>".
						str_replace("\n","<br>",$paesi)."<br><br>
						<u>$lang_page_visits</u>:<br>".
						str_replace("\n","<br>",$pagine)."<hr>";

					// draw charts
					$from = date('j M y',strtotime(str_replace("/","-",$from)));
					$to = date('j M y',strtotime(str_replace("/","-",$to)));
					$from = str_replace(array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov"."Dec"),$lang_month,$from);
					$to = str_replace(array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov"."Dec"),$lang_month,$to);
					$tipi = array("lingua","paese","pagina");
					foreach ($tipi as $tipo) {
						$js_1 = '
						<script>
						window.onload = function() {

						var chart = new CanvasJS.Chart("chartContainer", {
							theme: "light2", // "light1", "light2", "dark1", "dark2"
							exportEnabled: true,
							animationEnabled: true,
							title: {
								text: "'.$lang_top_accesses;
						$js_2 = str_replace($tipi,$lang_by,$tipo);
						$js_3 = ', '.$from.'-'.$to;
						$js_4 = '"
							},
							data: [{
								type: "pie",
								startAngle: 25,
								toolTipContent: "<b>{label}</b>: {y}",
								showInLegend: "true",
								legendText: "{label}",
								indexLabelFontSize: 16,
								indexLabel: "{label} - {y}",
								dataPoints: ['."\n";
						$js_5 = ${$tipo.'_js'};
						$js_6 = '
								]
							}]
						});
						chart.render();

						}
						</script>
						<div id="chartContainer" style="height: 500px; max-width: 90%; margin: 0px auto;"></div>
						<script src="libs/canvasjs.min.js"></script>';
						${$tipo.'_chart'} = $js_1.$js_2.$js_3.$js_4.$js_5.$js_6;
					}
					echo '<form target="_blank" action="chart.php" method="post">
							<div class="form-group">
								<label style="font-weight:bold;" for="tipo">'.$lang_chart.'</label>
								<select class="form-control" id="tipo" name="tipo">
									<option value="lingua">'.str_replace($tipi,$lang_by,"lingua").'</option>
								    <option value="paese">'.str_replace($tipi,$lang_by,"paese").'</option>
								    <option value="pagina">'.str_replace($tipi,$lang_by,"pagina").'</option>
								</select>
							</div>
							<input type="submit" name="submit" id="submit" value='.$lang_submit.' required />
						</form>';
				?>
			</p>
			<p align="left"><font size="3">
				<?php
					// absolute counter
	  				$conta = file_get_contents("data/accessitotali.txt");
	  				echo "<hr><b>$conta</b> $lang_counter";
				?>
			</p>
			<hr>
		    <p align="left"><font size="3">
				<a href="logout.php"><?php echo $lang_logout; ?></a>
		    </p>
		</div>
    	<div class="col-md-1"></div>
	</div>
	<?php
		$_SESSION["lang"] = $language;
		$_SESSION["psw"] = $psw;
		$_SESSION["lingua"] = $lingua_chart;
		$_SESSION["paese"] = $paese_chart;
		$_SESSION["pagina"] = $pagina_chart;
	?>

</div>

</body>
</html>
